/*
  Copyright (C) 2010 Alexander Vorobiev.  All rights reserved.
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  See file LICENSE.txt for further informations on licensing terms.
*/


#include <avr/io.h>
#include "WProgram.h"
#include "InOutExtender.h"



// ---------------------------------------------------- TInOutExtender -----------------------------------------------

//  
#define INOUTEXT_SEROUT				8
#define	INOUTEXT_SHIFT				4
#define INOUTEXT_WRITE				9
#define INOUTEXT_READ				10
#define INOUTEXT_SERIN				2



// inOutCount -  /
TInOutExtender::TInOutExtender(uint8_t inOutCount/*=16*/) {
	m_InOutCount = inOutCount;
}


void TInOutExtender::Setup(void) {
	//   -
	pinMode(INOUTEXT_SEROUT, OUTPUT);
	pinMode(INOUTEXT_SHIFT, OUTPUT);
	pinMode(INOUTEXT_WRITE, OUTPUT);
	pinMode(INOUTEXT_READ, OUTPUT);
	pinMode(INOUTEXT_SERIN, INPUT);
	//  
	digitalWrite(INOUTEXT_READ, HIGH);
}

// /
void TInOutExtender::ReadWrite(uint16_t* in,uint16_t out) {
	*in = 0;
	uint8_t counter;

	digitalWrite(INOUTEXT_READ, LOW); //  
	//      
	out <<= (16 - m_InOutCount);
	digitalWrite(INOUTEXT_READ, HIGH);
	digitalWrite(INOUTEXT_WRITE, LOW); //    

	for(counter=0;counter<m_InOutCount;counter++) {
		//    
		digitalWrite(INOUTEXT_SHIFT, LOW);
		
		//   
		//    
		(*in) >>= 1;
		if( digitalRead(INOUTEXT_SERIN) ) (*in) |= 0x8000;

		//   
		digitalWrite( INOUTEXT_SEROUT, (out & 0x8000)?HIGH:LOW );
		out <<= 1;

		// 
		digitalWrite(INOUTEXT_SHIFT,HIGH);
	}

	//   
	(*in) >>= (16 - m_InOutCount);

	digitalWrite(INOUTEXT_WRITE, HIGH); //  

}


// -------------------------------------------- TInOutExtenderS ------------------------------------------------------

TInOutExtenderS::TInOutExtenderS(uint8_t inOutCount/*16*/)
: TInOutExtender(inOutCount), m_In(0), m_Out(0) {
}


void TInOutExtenderS::ReadWrite(void) {
	TInOutExtender::ReadWrite(&m_In,m_Out);
}

